MultBCxDEx2:
	call	MultBCxDE
	add	hl,hl
	rl	e
	rl	d
	ret

;Inputs: BC, DE
;Output: DE:HL = BC * DE
function(MultBCxDE):
	xor	a
	ld	h,a
	ld	l,a
	or	b
	jp	p,@FirstOkay
	sbc	hl,de
@FirstOkay:
	xor	a
	or	d
	jp	p,@SecondOkay
	sbc	hl,bc
@SecondOkay:
	add	hl,hl	\ rl e \ rl d \ jp nc,$+11\ add hl,bc \ jp nc,$+7 \ ld a,e \ xor 1 \ ld e,a
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc e
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc e
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc e
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc e
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc e
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc e
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc e
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc de
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc de
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc de
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc de
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc de
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc de
	add	hl,hl	\ rl e \ rl d \ jp nc,$+8 \ add hl,bc \ jp nc,$+4 \ inc de
	add	hl,hl	\ rl e \ rl d \ ret nc    \ add hl,bc \ ret nc    \ inc de
	ret

function(MultHxC):
	ld	a,b
	ld	b,0
	ld	l,b
	sla	h
	jr	nc,@Skip
	ld	l,c
@Skip:
	add	hl,hl \ jr nc,$+3 \ add hl,bc
	add	hl,hl \ jr nc,$+3 \ add hl,bc
	add	hl,hl \ jr nc,$+3 \ add hl,bc
	add	hl,hl \ jr nc,$+3 \ add hl,bc
	add	hl,hl \ jr nc,$+3 \ add hl,bc
	add	hl,hl \ jr nc,$+3 \ add hl,bc
	add	hl,hl \ jr nc,$+3 \ add hl,bc
	ld	b,a
	ret

function(DivHLbyC):
	xor	a
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	add	hl,hl \ rla \ jr c,$+5 \ cp c \ jr c,$+4 \ sub c \ inc l
	ret

Line = tempSwapArea
function(LineBegin):
	ld	a,h
	cp	d
	jr	nc,@Ordered
	ex	de,hl
@Ordered:
	ld	c,e
	ld	b,d
	push	bc
	push	hl
	ld    hl,FP_Bits
	ld    a,b
	and   $07
	add   a,l
	ld    l,a
	adc   a,h
	sub   l
	ld    h,a
	ld    a,[hl]
	ld    h,0
	ld    l,c
	add   hl,hl
	add   hl,hl
	ld    d,h
	ld    e,l
	add   hl,hl
	add   hl,de
	ld    d,0
	ld    e,b
	srl   e
	srl   e
	srl   e
	add   hl,de
	ld	de,saveSScreen
	add	hl,de
	pop	de
	pop	bc
;Connected:
	push	hl
	ld	h,c
	ld	c,a
	ld	a,d
	sub	b
	ld	b,a
	ld	a,e
	jr	nz,@NotPoint
	cp	h
	jr	nz,@NotPoint
	pop	hl
	ld	a,[hl]
	or	c
	ld	[hl],a
	ret
@NotPoint:
	sub	h
	ld	de,12
	jr	nc,@PositiveY
	neg
	ld	de,-12
@PositiveY:
	cp	b
	jr	nc,@Steep
	;add	a,a
	ld	[@Line2sm + 1],a
	ld	h,a
	xor	a
	sub	b
	;sub	b
	ld	[@Line1sm + 1],a
	ld	a,h
	sub	b
	pop	hl
@LoopGentle:
	ex	af,af'
	ld	a,[hl]
	or	c
	ld	[hl],a
	rrc	c
	jr	nc,$+3
	inc	hl
	ex	af,af'
	jp	m,@Line2sm
@Line1sm = $ - LineBegin + Line
	add	a,0
	add	hl,de
@Line2sm = $ - LineBegin + Line
	add	a,0
	djnz	@LoopGentle
	ld	a,[hl]
	or	c
	ld	[hl],a
	ret
@Steep:
	ld	h,a
	xor	a
	sub	h
	;sub	h
	ld	[@Line3sm + 1],a
	ld	a,b
	;add	a,b
	ld	[@Line4sm + 1],a
	sub	h
	ld	b,h
	pop	hl
@LoopSteep:
	ex	af,af'
	ld	a,[hl]
	or	c
	ld	[hl],a
	add	hl,de
	ex	af,af'
	jp	m,@Line4sm
@Line3sm = $ - LineBegin + Line
	add	a,0
	rrc	c
	jr	nc,$+3
	inc	hl
@Line4sm = $ - LineBegin + Line
	add	a,0
	djnz	@LoopSteep
	ld	a,[hl]
	or	c
	ld	[hl],a
	ret
LineSize = $ - LineBegin

FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01

;HL -> sprite; draws at (B,C)
function(PutSprite):
	push	bc
	push	de
	push	hl
	push	ix
	ld	a,$FF
	ld	[clipmask],a
	bit	7,b
	jr	z,@CheckRightClip
	ld	a,b
	cp	249
	jp	c,@EndPS
	neg
	push	bc
	ld	b,a
	ld	a,$FF
@LeftClip:
	srl	a
	djnz	@LeftClip
	ld	[clipmask],a
	pop	bc
	ld	a,b
	add	a,96
	ld	b,a
	dec	c
	jr	@CheckBotClip
@CheckRightClip:
	ld	a,[clipx]
	sub	b
	jr	nc,@CheckBotClip
	neg
	push	bc
	ld	b,a
	inc	b
	ld	a,$FF
@RightClip:
	add	a,a
	djnz	@RightClip
	ld	[clipmask],a
	pop	bc
@CheckBotClip:
	ld	a,7
	ld	[rows2put],a
	bit	7,c
	jr	nz,@CheckTopClip
	ld	a,62
	sub	c
	jp	c,@EndPS
	inc	a
	cp	7
	jr	nc,@ClippingDone
	ld	[rows2put],a
	jr	@ClippingDone
@CheckTopClip:
	ld	a,c
	cp	251
	jr	c,@EndPS
	push	bc
	neg
	ld	b,a
	sub	7
	neg
	ld	[rows2put],a
@TopClip:
	inc	hl
	inc	hl
	djnz	@TopClip
	pop	bc
	ld	c,0
@ClippingDone:
	push	hl
	pop	ix
	ld	a,[rows2put]
	push	af
	push	bc
	push	de
	ld	hl,FP_Bits
	ld	d,0
	ld	a,b
	and	$07
	ld	e,a
	add	hl,de
	ld	e,[hl]
	ld	h,d
	srl	b
	srl	b
	srl	b
	ld	a,c
	add	a,a
	add	a,a
	ld	l,a
	ld	a,e
	ld	e,l
	add	hl,hl
	add	hl,de
	ld	e,b
	add	hl,de
	pop	de
	pop	bc
	ld	de,saveSScreen
	add	hl,de
	ld	d,a
	pop	bc
@PutRow:
	push	bc
	push	hl
	ld	a,[clipmask]
	and	[ix]
	inc	ix
	ld	e,a
	ld	b,8
	ld	c,[ix]
	inc	ix
@PutCol:
	push	bc
	rlc	e
	jr	nc,@NextBit
	ld	a,d
	rlc	c
	jr	c,@BitOn
	cpl
	and	[hl]
	ld	[hl],a
	jr	@NextBit
@BitOn:
	or	[hl]
	ld	[hl],a
@NextBit:
	rrc	d
	jr	nc,@SSB
	inc	hl
@SSB:
	pop	bc
	rlc	c
	djnz	@PutCol
	pop	hl
	ld	bc,12
	add	hl,bc
	pop	bc
	djnz	@PutRow
@EndPS:
	pop	ix
	pop	hl
	pop	de
	pop	bc
	ret

GetKey:
	bcall	_GetKey
	res	onInterrupt,[iy + onFlags]
	cp	kQuit
	jp	z,ForceExit
	or	a
	jr	z,GetKey
	ret

StrCpy:
	ld	a,[hl]
	ldi
	or	a
	jr	nz,StrCpy
	ret

Mov18FrOP1:
	ld	hl,OP1
	ld	bc,9
	push	bc
	ldir
	ld	hl,OP2
	pop	bc
	ldir
	ret

